# Internal structure of Hyde lib

Note: If you want to start hacking on Hyde and extending it, follow this
layout as closely as possible.

## Core classes

These are core classes of Hyde and they are loaded as soon as the library is loaded.

- Hyde::Path [path.rb]
- Hyde::PathBinding [path.rb]
- Hyde::Probe [probe.rb]
- Hyde::ProbeBinding [probe.rb]
- Hyde::Node (parent of Path and Probe) [node.rb]
- Hyde::Server (Rack application interface) [server.rb]
- Hyde::ServerBinding [server.rb]
- Hyde::Request (Rack request wrapper) [request.rb]
- Hyde::Response (Rack response wrapper) [response.rb]
- Hyde::Pattern [pattern\_matching.rb]

## Patterns

These are classes that Hyde::Pattern can interface with to create Patterns.

- Hyde::PatternMatching::ReMatch [pattern\_matching/rematch.rb]
- Hyde::PatternMatching::Glob [pattern\_matching/glob.rb]

## DSL Method mixins

These are module mixins that add common methods to DSL bindings.

- Hyde::DSL::PathConstructors [dsl/path\_constructors.rb]

## Utilities

These are self-contained classes and methods that add extra functionality to Hyde.

- Hyde::Util::Lookup [util/lookup.rb]

## Probe subclasses

These are reactive request handlers with their own semantics, if needed.

- Hyde::Handler [probe/handler.rb]
- Hyde::GETHandler [probe/http\_method.rb]
- Hyde::POSTHandler [probe/http\_method.rb]
- Hyde::HEADHandler [probe/http\_method.rb]
- Hyde::PUTHandler [probe/http\_method.rb]
- Hyde::DELETEHandler [probe/http\_method.rb]
- Hyde::CONNECTHandler [probe/http\_method.rb]
- Hyde::OPTIONSHandler [probe/http\_method.rb]
- Hyde::TRACEHandler [probe/http\_method.rb]
- Hyde::PATCHHandler [probe/http\_method.rb]

## Path subclasses

These are navigation handlers with their own semantics.

(currently none)
