# frozen_string_literal: true

$LOAD_PATH.unshift("#{File.dirname(__FILE__)}/lib")
require_relative 'lib/hyde'

app = Hyde::Server.new do
  preprocess do |request|
    puts "New request: #{request}"
  end
  filter do
    rand < 0.9
  end
  postprocess do |request, response|
    puts "Request: #{request}, response: #{response}"
  end
  index ["index.html"]
  root "#{ENV['PWD']}/assets"
  serve "/**/*.(html|css|js)"
  get "/wormhole/:test/*" do |suffix, test: nil|
    <<~RESPONSE
      You tried accessing #{suffix} at named param #{test}
      Your request is a #{request} object

      #{Hyde::VLINE}
    RESPONSE
  end
  get "/bounce-random" do
    bounce if rand < 0.5
    "you win!"
  end
  get "/404" do
    die(404, backtrace: ["backtrace field", "you can write a lot of crap here"])
  end
end

run app
