# frozen_string_literal: true

module Hyde
  module PatternMatching
    # Strips extra slashes from a string.
    # (including slashes at the start and end of the string)
    # @param string [String]
    # @return [String]
    def self.canonicalize(string)
      string.gsub(/\/+/, "/")
            .delete_prefix("/")
            .delete_suffix("/")
    end
  end
end
