# frozen_string_literal: true

module Hyde
  # Various things that exists for purely logical reasons
  module Util
    # Value container with recursive lookup
    class Lookup
      # @param parent [Lookup, nil]
      def initialize(parent = nil, hash = {})
        @parent = (parent or Hash.new(nil))
        @storage = hash
      end

      # Initialize a Lookup from Hash
      # @param hash [Hash]
      def self.[](hash)
        Lookup.new(nil, Hash[hash])
      end

      # Get a value by key
      # @param key [#hash] key for value
      # @return [Object,nil]
      def [](key)
        @storage[key] or @parent[key]
      end

      # Set a value by key
      # @param key [#hash] key for value
      # @param value [Object] value value
      def []=(key, value)
        @storage[key] = value
      end

      attr_accessor :parent
    end
  end
end
