# frozen_string_literal: true

module Hyde
  module Util
    # Internal library for generating form hashes
    module ParserCommon
      private

      # Sort key-value pair arrays
      def sort(hash)
        hash.filter { |_, v| v.is_a? Array }.each do |_, value|
          value.sort_by! { |array| array[0].to_i }
        end
        hash
      end

      # Flatten key-value pair arrays
      def flatten(hash)
        hash.transform_values do |value|
          if value.is_a? Array
            new_array = []
            value.each do |k, v|
              if k.match?(/\d+/) and k.to_i < new_array.size
                new_array[k.to_i] = v
              else
                new_array.append(v)
              end
            end
            new_array
          else
            value
          end
        end.to_h
      end
    end
  end
end
