# frozen_string_literal: true

require_relative "../lib/hyde/pattern_matching"
require "test/unit"

class TestReMatch < Test::Unit::TestCase
  include Hyde::PatternMatching
  # match? test
  def test_matchq
    a = ReMatch.new(/^test\/path_[^\/]+/)
    assert_equal(true, a.match?("/test/path_1"))
    assert_equal(false, a.match?("/test/path"))
    assert_equal(false, a.match?("test/path/anything"))
    assert_equal(true, a.match?("/test/path_1/extra"))
  end

  def test_match
    a = ReMatch.new(/^test\/path_([^\/]+)/)
    assert_equal(["", ["1"], {}], a.match("/test/path_1"))
    assert_equal(false, a.match("/test/path"))
    assert_equal(false, a.match("test/path/anything"))
    assert_equal(["/extra", ["1"], {}], a.match("/test/path_1/extra"))
  end
end
