# frozen_string_literal: true

require_relative "../lib/hyde/util/lookup"
require "test/unit"

class TestLookup < Test::Unit::TestCase
  include Hyde::Util
  def test_lookup
    assert_equal(true, Lookup.new().is_a?(Lookup))
    assert_equal(true, Lookup.new(Lookup.new()).is_a?(Lookup))
    assert_equal(true, Lookup[{"a" => :b}].is_a?(Lookup))
    testing_lookup = Lookup[{"a" => 1}]
    assert_equal(1, Lookup.new(testing_lookup)["a"])
    lookup2 = Lookup.new(testing_lookup)
    assert_equal(1, lookup2["a"])
    testing_lookup["a"] = 2
    assert_equal(2, lookup2["a"])
    lookup2["a"] = 3
    testing_lookup["a"] = 4
    assert_equal(3, lookup2["a"])
  end
end
