# frozen_string_literal: true

require_relative "../lib/hyde/util/query"
require "test/unit"

class TestQuery < Test::Unit::TestCase
  include Hyde::Util
  def test_query
    test1 = Query.new("key1=1&key2=2&key3[]=1&key3[]=2&key3[]=3")
    assert_equal({"key1"=>"1","key2"=>"2","key3"=>["1","2","3"]},test1.parse)
    test2 = Query.new("key1[1]=1&key1[500]=3&key1[50]=2")
    assert_equal({"key1"=>["1","2","3"]},test2.parse)
    test3 = Query.new("array[]=1&array[]=2&array[0]=0&array[500]=3")
    assert_equal({"array"=>["0","2","3"]},test3.parse)
  end
end
